<?php
	require 'external/aws/aws-autoloader.php';
	use Aws\S3\S3Client;
	use Aws\S3\Exception\S3Exception;
    function GUID()
    {
        if (function_exists('com_create_guid') === true)
        {
            return trim(com_create_guid(), '{}');
        }
    
        return sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X', mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(16384, 20479), mt_rand(32768, 49151), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535));
    }

    function generateUploadedPresignedURL($fromUserId){

        $credentials = [
            'key' => 'AKIA4ROQEOUP4XZNNHHA',
            'secret' => '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',
        ];

        $bucket = 'quiklrnreports';
        $region = 'ap-south-1';

        $s3 = new S3Client([
            'version' => 'latest',
            'region' => $region,
            'credentials' => $credentials,
        ]);

        $file = "../../../tmp/output.csv";

        // Specify the key (name) under which the file will be stored in the S3 bucket
        $gUid = GUID();
        $key = $fromUserId."/".$gUid.".csv";

        try {
            $result = $s3->putObject([
                'Bucket' => $bucket,
                'Key' => $key,
                'SourceFile' => $file,
            ]);

            // Get a pre-signed URL for the uploaded file
            $cmd = $s3->getCommand('GetObject', [
                'Bucket' => $bucket,
                'Key' => $key,
            ]);

            $request = $s3->createPresignedRequest($cmd, '+7 days');
            $presignedUrl = (string) $request->getUri();
        
            // echo 'File uploaded successfully. Pre-signed URL: ' . $presignedUrl;
        } catch (AwsException $e) {
            // echo 'Error uploading file: ' . $e->getMessage();
            $api_error = $e->getMessage();
        }
        
        if(empty($api_error)){ 
            $status = 'success'; 
            $statusMsg = ['status_code'=>200, 'msg' => "File was uploaded to the S3 bucket successfully!", 'objectURI' => $presignedUrl]; 
        }else{ 
            $statusMsg = ['status_code'=>401, 'msg' => $api_error, 'objectURI' =>'']; 
        } 
        return $statusMsg;

    }

?>

